//DEFINEs
#define WEBSERVER_ESP_WIFI_SSID      "default"
#define WEBSERVER_ESP_WIFI_PASS      "default123"
#define WEBSERVER_ESP_MAXIMUM_RETRY      10
#define WEBSERVER_ESP_STATION_PASSWORD  "test_123"
#define WEBSERVER_ESP_STATION_NAME      "Schaltsteckdose"
#define NTPSERVICE "pool.ntp.org"
#define GPIO_OUTPUT_IO_0    15
#define GPIO_OUTPUT_IO_1    16
#define GPIO_INPUT_IO_0     12
#define GPIO_INPUT_IO_1     14
#define GPIO_INPUT_PIN_SEL  ((1ULL<<GPIO_INPUT_IO_0) | (1ULL<<GPIO_INPUT_IO_1))
#define GPIO_OUTPUT_PIN_SEL  ((1ULL<<GPIO_OUTPUT_IO_0) | (1ULL<<GPIO_OUTPUT_IO_1))
#define WIFI_CONNECTED_BIT BIT0
#define WIFI_FAIL_BIT      BIT1
#define RECUR_DAY           1
#define RECUR_WEEK          2
#define RECUR_MONTH         3
#define RECUR_YEAR          4
#define RECUR_ONCE          5
#define PORT_OFF            0
#define PORT_ON             1
#define PORT_TIMER          2
#define PORT_SWITCHLIST     3
#define CONFIG_MODE         4
#define CONFIG_ACTIONS_MODE 5
#define CONFIG_SAVE         6
#define CONFIG_FAILED       7
#define CONFIG_ACTIONS_FAILED       8
#define CONFIG_ACTIONS_FAILED_DUP   9

//Max number of entries in SWITCHLIST
#define SWITCHLIST_SIZE     40

//Firmware version
#define FIRMWARE_VERSION "v0.6"

//firmware update url, should be SSL secured.
#define OTA_SERVER_URL "https://192.168.100.2/webserver.bin"
//#define OTA_SERVER_URL "http://raw.githubusercontent.com/wiki/espressif/esp-jumpstart/images/hello-world.bin"

//certificate of OTA server in PEM format
#define OTA_SERVER_CERT "-----BEGIN CERTIFICATE-----\n\
MIIF9TCCA92gAwIBAgIUDzqj7BCTDj5GKOCvPqwiRXSr/nEwDQYJKoZIhvcNAQEL\n\
BQAwgYkxCzAJBgNVBAYTAkRFMQ4wDAYDVQQIDAVCYWRlbjETMBEGA1UEBwwKTmVj\n\
a2Fyc3VsbTENMAsGA1UECgwEdG9iaTEOMAwGA1UECwwFYWRtaW4xFjAUBgNVBAMM\n\
DTE5Mi4xNjguMTAwLjIxHjAcBgkqhkiG9w0BCQEWD3RvYml3QHBvc3Rlby5kZTAe\n\
Fw0yMTA5MDIxMjI0NTJaFw0yMjA5MDIxMjI0NTJaMIGJMQswCQYDVQQGEwJERTEO\n\
MAwGA1UECAwFQmFkZW4xEzARBgNVBAcMCk5lY2thcnN1bG0xDTALBgNVBAoMBHRv\n\
YmkxDjAMBgNVBAsMBWFkbWluMRYwFAYDVQQDDA0xOTIuMTY4LjEwMC4yMR4wHAYJ\n\
KoZIhvcNAQkBFg90b2Jpd0Bwb3N0ZW8uZGUwggIiMA0GCSqGSIb3DQEBAQUAA4IC\n\
DwAwggIKAoICAQCwGcdzjDWzYaKACkZ5kaFORGS0vQxNcQ0x9unOvHJjWjgQdx44\n\
1SFO1D9gVHT19ayYbuKN2nMi9hJzePuD4YqV5887bnNC908IohZkyL5Lnr+eMApW\n\
V2ljGKcIKyE/mpP9MQgNp+PqsK8mH5gc/cE/cYu08LZGt3ydZ8fDIjgetKU2ouFu\n\
k+uKmCXa5mZM+li123h2nYJTOs8RgDK/dUOrzNDPbNknEuZUeXA3lo+gZ1+KlH+F\n\
zrMGQ9as/+miX5vk0GgTALERlnC3N1PE4lVaS2ozW2vqmwaS/Q0w63SDhuyc5KDv\n\
D17gxv7gLSCIEL5IDLa5aqj/jjKL2dwFNoP8O4klPuSK8obgaH+uSWwXK6y4g1la\n\
BTdE+lUfO/hR9dnUhCuI+PCYXsY2b/kGQvqk/ICyMt4QcrxrYv8ULZqVJZAkXm1E\n\
+iPDGuCofBnOeSXnzwJDAsPsvIW2ql2dTKM0F+GbGanxiSp7WAvRj6Q9CHmddXf6\n\
WTuf6Ln98F2WRSkEc22v5qGhr6F6SyXoXVWpf1IQ5ZDHmy+BnkUFeMnPt7ScEzNC\n\
1/2CcSeEO1K2z1sj7yTshCNuZWIQGTPuX1NV6hCeWZoC6RQbQ97hu4dqNp22+OnC\n\
lW4wAxxOZbTtfRvviJnbJ4f7tonBEXISxNLNKwNfsUh55l0F4JWRI6CpswIDAQAB\n\
o1MwUTAdBgNVHQ4EFgQU/2dcRr+g32kxpirUU6uVfX3pqnkwHwYDVR0jBBgwFoAU\n\
/2dcRr+g32kxpirUU6uVfX3pqnkwDwYDVR0TAQH/BAUwAwEB/zANBgkqhkiG9w0B\n\
AQsFAAOCAgEAir+TK/xIyHLByxfXeqFiHb10Nd3VxefVfpPKavRActkgdaxk5q9Z\n\
pYZlGUBX/IP1j8kBefWNhUf4vaB0eB/jCYU2WtWxg/yp39z3/ap8ivafNOe+tbKD\n\
jbZjaP9dmNRKwixUu7WJAbhGfTM9ZSwp4iFFsPPaMRvSHsM9kHV3lTvOchVE7gjP\n\
UXTJBIhxEZO3wfbJkLh64oH2UgJxICeIpB94cgtERQ/cYhIluUXtpZyfn8/8QuOr\n\
gxsGgZBc8Fh7c/N8cJ9tCIWXmNj0bOXOydiPZ+BJlhLi9gqJRlF4fRi/UyhZKR/+\n\
xJJVLqPuRjbmrmLtyERtzFvvveWHLdE9jvzyzadzGWBq46TLyxdADHGxfiJGCecY\n\
JhcpYTuQdkCKjw1Jjs+R/DSO52q3VzcOLnDmrewmT5QHZPopgdqCNRiSDHD7fjJs\n\
NAfphZj9lPvtwo94CbEVhliDGwVyUBFITpDa3mk5l0KEhFWTFvtULWKR1kuoIIFi\n\
V8ICPIkdS8WJlF3QvcJuaZ0COP7yUHSTO0SrSm4UCrjS7zvWvcuMW3rNf5lH2npH\n\
FX6T/QpLnbxqPB/JXaofYlPXOOQLuuRG5imyALG9Oq5saVvK5BgU+nIFTLMpxkJd\n\
x2Wx7DwJaBJg1PAdueBkmdYryMu0x/ZQYJkbGp/t6r40AULL2byjfkU=\n\
-----END CERTIFICATE-----\n"

//Global variables

//TAG
static const char *TAG="webserver";

//our website
char user_str[6144];
time_t now;
struct tm timeinfo;
char strftime_buf[64];
    
/* FreeRTOS event group to signal when we are connected*/
static EventGroupHandle_t s_wifi_event_group;

static int s_retry_num = 0;
static httpd_handle_t server = NULL;

// status = Port status (0=off, 1=on), wifi state = wifi status (0=not connected, 1=connected), button pressed = indicator for button pressed
// delay count = delay for button debounce, next_switch_delay = delay between port switches, startup_in_progress = indicator for boot process
// cfg_err = used to store config mistakes temporary in a bit mask
int status = 0, wifi_state = 0, button_pressed = 0, delay_count = 0, next_switch_delay = 0, startup_in_progress = 0, restart_in_progress = 0, cfg_err = 0, timer_sec = 0, timer_min = 0, switch_action_done = 0, switch_action_timer = 60;
char event_id[3];

//Functions

//http.c
void generate_day_menu(int day, int type);
void generate_month_entry(int month);
void generate_month_menu(int month, int type);
void generate_week_entry(int tm_wday_tmp);
void generate_week_menu(int tm_wday_tmp);
void generate_response(int gen_page_id); 

//init.c
void init_spiffs(void);
void init_ports(void);
static void init_sntp(void);
void wifi_init_sta(void);

//interrupt.c
static void IRAM_ATTR gpio_isr_handler(void *arg);
void hw_timer_callback1(void *arg);

//server.c
esp_err_t cfgsav_get_handler(httpd_req_t *req);
esp_err_t config_get_handler(httpd_req_t *req);
esp_err_t config_actions_get_handler(httpd_req_t *req);
esp_err_t cfgsav_actions_get_handler(httpd_req_t *req);
esp_err_t switch_get_handler(httpd_req_t *req);
esp_err_t root_get_handler(httpd_req_t *req);
httpd_handle_t start_webserver(void);
void stop_webserver(httpd_handle_t server);

//util.c
void config_read(void);
void config_write(int fstatus);
static void connect_handler(void* arg, esp_event_base_t event_base, int32_t event_id, void* event_data);
static void disconnect_handler(void* arg, esp_event_base_t event_base,int32_t event_id, void* event_data);
static void event_handler(void* arg, esp_event_base_t event_base,int32_t event_id, void* event_data);
esp_err_t http_client_event_handler(esp_http_client_event_t *evt);
char from_hex(char ch);
int get_day_number(char *s);
int get_month_number(char *s);
int isIp_v4( char* ip);
static void obtain_time(void);
void ota_updater(void);
void port_switch(int port_status);
int qsort_helper( const void *left, const void *right );
void switch_checker(void);
char *url_decode(char *str);
int valid_digit(char* ip_str);

//Structs 

//URI handler structs
httpd_uri_t cfgsav_uri = {
    .uri       = "/cfgsav",
    .method    = HTTP_GET,
    .handler   = cfgsav_get_handler,
    /* Let's pass response string in user
     * context to demonstrate it's usage */
    .user_ctx  = NULL
};

httpd_uri_t config_uri = {
    .uri       = "/config",
    .method    = HTTP_GET,
    .handler   = config_get_handler,
    /* Let's pass response string in user
     * context to demonstrate it's usage */
    .user_ctx  = NULL
};

httpd_uri_t cfgsav_actions_uri = {
    .uri       = "/cfgsavactions",
    .method    = HTTP_GET,
    .handler   = cfgsav_actions_get_handler,
    /* Let's pass response string in user
     * context to demonstrate it's usage */
    .user_ctx  = NULL
};

httpd_uri_t config_actions_uri = {
    .uri       = "/configactions",
    .method    = HTTP_GET,
    .handler   = config_actions_get_handler,
    /* Let's pass response string in user
     * context to demonstrate it's usage */
    .user_ctx  = NULL
};

httpd_uri_t switch_uri = {
    .uri       = "/switch",
    .method    = HTTP_GET,
    .handler   = switch_get_handler,
    /* Let's pass response string in user
     * context to demonstrate it's usage */
    .user_ctx  = NULL
};

httpd_uri_t root_uri = {
    .uri       = "/",
    .method    = HTTP_GET,
    .handler   = root_get_handler,
    /* Let's pass response string in user
     * context to demonstrate it's usage */
    .user_ctx  = NULL
};

//configuration
typedef struct
{
    char ssid[34];      //Wlan SSID 
    char password[66];  //Wlan password
    char name[34];      //Station name
    char ip[18];        //IP address
    char gw[18];        //Default gateway
    char netmask[18];   //Subnet mask
    char dns1[18];        //DNS1
    char dns2[18];        //DNS2
    char use_dhcp[5];      //use DHCP
    char station_password[66];  //Station password
    char use_authorization[5];  //Authorize switch actions via password
    char auto_ota[5];  //Authorize switch actions via password
    char use_actions[5]; //use planned actions
    
}
config_struct;

config_struct config;

typedef struct
{
    int event_status;
    int tm_min;
    int tm_hour;
    int tm_wday;
    int tm_daynr;
    int tm_monthnr;
    int recurring;
    int switch_status;

}
time_struct;

time_struct switch_times[SWITCHLIST_SIZE];

